# RPM spec file for Gtk2HS   -*-rpm-spec-*-
#
# Copyright [2001..2002] Manuel M T Chakravarty <chak@cse.unsw.edu.au>
# Copyright 2002, 2003 Jens-Ulrik Holger Petersen <petersen@haskell.org>

%define ghc_version 6.0.1

Summary: Haskell binding for the GIMP Toolkit (GTK2), a GUI library
Name: gtk2hs
Version: 0.9.5
Release: 0.%(date +%%Y%%m%%d)
Copyright: LGPL
Group: Development/Libraries
Source: gtk2hs-%{version}.tar.gz
URL: http://gtk2hs.sourceforge.net/
BuildRoot: /var/tmp/gtk2hs-%{version}-%{release}-root

%description
A Gtk2 binding for the functional language Haskell featuring
automatic memory management, unicode support, and quite wide
coverage of widget functions and their signals, including
the new text and list widgets.  The convenience wrapper
MoGuL (Monad Gui Library) makes it possible to create and
lookup named widgets in a type safe way.

%package ghc%{ghc_version}
Summary: Haskell binding for the GIMP Toolkit (GTK2), a GUI library
Group: Development/Languages/Haskell
BuildRequires: ghc = %{ghc_version}, gtk2-devel, gtksourceview-devel, %{?_with_c2hs: c2hs >= 0.10.6}, %{_bindir}/hsc2hs
Requires: ghc = %{ghc_version}
Requires: gtk2, gtksourceview
Requires(post,preun): %{_bindir}/ghc-pkg-%{ghc_version}

%description ghc%{ghc_version}
A Gtk2 binding for the functional language Haskell featuring
automatic memory management, unicode support, and quite wide
coverage of widget functions and their signals, including
the new text and list widgets.  The convenience wrapper
MoGuL (Monad Gui Library) makes it possible to create and
lookup named widgets in a type safe way.

This package contains the libraries compiled for ghc-%{ghc_version}.

%package doc
Summary: Haskell binding for the GIMP Toolkit (GTK2), a GUI library
Group: Development/Languages/Haskell

%description doc
A Gtk2 binding for the functional language Haskell featuring
automatic memory management, unicode support, and quite wide
coverage of widget functions and their signals, including
the new text and list widgets.  The convenience wrapper
MoGuL (Monad Gui Library) makes it possible to create and
lookup named widgets in a type safe way.

This package contains the gtk2hs documentation.

# the debuginfo subpackage is currently empty anyway, so don't generate it
%define debug_package %{nil}
%define __spec_install_post /usr/lib/rpm/brp-compress

%prep
%setup -q

%build
./configure %{?c2hs: --with-c2hs=%{c2hs}} --with-hc=ghc-%{ghc_version} --with-hcflags="-O" --with-catalog=%{_datadir}/sgml/docbook/xmlcatalog --with-html=%{_datadir}/sgml/docbook/xsl-stylesheets/xhtml/chunk.xsl # --with-fo=%{_datadir}/sgml/docbook/xsl-stylesheets/fo/docbook.xsl
make prefix=%{_prefix} libdir=%{_libdir}/ghc-%{ghc_version}

%install
rm -rf %{buildroot}
make DESTDIR=%{buildroot} prefix=%{_prefix} libdir=%{_libdir}/ghc-%{ghc_version} install-without-pkg

mkdirhier %{buildroot}%{_datadir}/gtksourceview-1.0/language-specs
cp -p demo/sourceview/haskell.lang %{buildroot}%{_datadir}/gtksourceview-1.0/language-specs

# hack to avoid demo binaries in docs 
make clean MAKE_GOALS="demo/concurrent demo/treeList demo/graphic demo/unicode demo/hello demo/sourceview"

%clean
rm -rf %{buildroot}

%post ghc%{ghc_version}
# # remove buildroot traces from package files
# perl -pi -e "s|%{buildroot}||" \
#     %{_libdir}/ghc-%{ghc_version}/{%{name}/gtk2.conf,mogul.conf}

ghc-pkg-%{ghc_version} -u -g -i %{_libdir}/ghc-%{ghc_version}/%{name}/gtk2/gtk2.conf
ghc-pkg-%{ghc_version} -u -g -i %{_libdir}/ghc-%{ghc_version}/%{name}/sourceview/sourceview.conf
ghc-pkg-%{ghc_version} -u -g -i %{_libdir}/ghc-%{ghc_version}/%{name}/mogul/mogul.conf

%preun ghc%{ghc_version}
if [ "$1" = 0 ]; then
  rm -f %{_libdir}/ghc-%{ghc_version}/%{name}/{gtk2/gtk2hs.o,mogul/mogul.o,spirceview/sourceview.o}
  ghc-pkg-%{ghc_version} -r mogul || :
  ghc-pkg-%{ghc_version} -r sourceview || :
  ghc-pkg-%{ghc_version} -r gtk2 || :
fi

%files ghc%{ghc_version}
%defattr(-,root,root) 
%{_prefix}/lib/*
%{_datadir}/gtksourceview-1.0/language-specs/haskell.lang
%doc ChangeLog TODO AUTHORS COPYING.LIB

%files doc
%defattr(-,root,root) 
%doc demo
%doc doc/GTK
%doc doc/MOGUL

%changelog
* Tue Nov 11 2003 Jens Petersen <petersen@haskell.org>
- use %%c2hs instead of "--with c2hs" to configure c2hs program
- clean demo to avoid binary files in docs dir

* Mon Nov  3 2003 Jens Petersen <petersen@haskell.org>
- add sourceview package to %%post and %%preun
- install gtksourceview haskell.lang language-spec

* Thu Jul 31 2003 Jens Petersen <petersen@haskell.org>
- build with ghc-6.0.1
- put demo dir in docs dir rather than individual source files

* Thu Jul 10 2003 Jens Petersen <petersen@haskell.org>
- build with ghc-6.0
- name ghc subpackage "ghc%%{ghc_version}"

* Wed Jun 18 2003 Jens Petersen <petersen@haskell.org>
- require and buildrequire %{_bindir}/ghc-%%{ghc_version}

* Wed May 21 2003 Jens Petersen <petersen@haskell.org>
- add -g option to ghc-pkg -u so that ghci object gets generated
- delete them when uninstalling
- build and include mogul documentation

* Thu May 15 2003 Jens Petersen <petersen@haskell.org>
- use new DESTDIR make variable, so no longer need to fix config files in post
- remove buildroot before install
- build and include gtk docs

* Fri Jan 10 2003 Jens Petersen <petersen@haskell.org>
- made into .spec.in file
- let configure set the version
- update description
- introduce --with-c2hs rpmbuild option
- use perl to remove buildroot traces from package conf files
- simplify ghc-pkg update commands

* Tue Dec 17 2002 Jens Petersen <petersen@haskell.org>
- latest cvs with ghc 5.04.2

* Thu Sep 26 2002 Jens Petersen
- build with ghc-5.04.1

* Fri Aug  2 2002 Jens Petersen
- only include demo source in doc dir

* Fri Jul 26 2002 Jens Petersen
- build with ghc-5.04
- cvs update

* Wed Jul 10 2002 Jens Petersen
- my current branch

* Wed May  1 2002 Jens Petersen
- patch TreeViewColumn.chs to make it usable

* Tue Apr 23 2002 Jens Petersen
- 0.9.0
- update gtk2 and mogul ghc-pkg entries on upgrade

* Fri Apr 12 2002 Jens Petersen
- adapt for gtk2hs
- fix mk files for buildroot install
- post and postun scriptlets for pkg config

* Tue Mar 12 2002 Manuel Chakravarty
- require a specific Haskell compiler (namely, the one for which the packages 
  was compiled)

* Sat Feb 17 2001 Manuel Chakravarty
- derived from C->Haskell's .spec file
